# SOFALookout

[![Build Status](https://travis-ci.org/sofastack/sofa-lookout.svg?branch=master)](https://travis-ci.org/sofastack/sofa-lookout)
[![Coverage Status](https://coveralls.io/repos/github/alipay/sofa-lookout/badge.svg?branch=master)](https://coveralls.io/github/alipay/sofa-lookout?branch=master)
![license](https://img.shields.io/badge/license-Apache--2.0-green.svg)
![maven](https://img.shields.io/github/release/alipay/sofa-lookout.svg)

Visit [WIKI](https://github.com/sofastack/sofa-lookout/wiki) for the full documentation, examples, and guides.

Lookout can help you to measure and monitor the status of the target system with its multi-dimensional metrics.
Lookout's multi-dimensional metrics refer to the [Metrics 2.0](http://metrics20.org/) standard.

- The client part of this project is a Java library.  You can instrument your code to collect metrics of your project.[more details](./client/README.md).
- The server part of this project is available now. Through this service, metrics data can be collected, processed, stored, and queried. In addition, it can work together with grafana to analyze and visualize data.

## Compared with common monitoring solutions, we have the following considerations:

- The concept of Metrics is not unfamiliar, so it is universal than other monitoring schemes without a data standard.
- Multi-dimensional metrics which is based on the name of the traditional metrics, adds a set of tags. so compared to dropwizard metrics, spring boot actuator metrics, etc. It can provide a richer tag dimension to help us monitor and analyze.
- The metrics solution is lighter than those monitoring and analysis by collecting and processing the logs and events generated by the application system. The consumption of system resources is also relatively fixed and will not increase with the increase in business volume.
- Lookout not only supports its own Java-SDK client acquisition source but also supports the data reporting of the mainstream agents in the industry.
- An acquisition source can locate lookout collecting services through the configuration file or a service discovery mechanism.
- Softwares in the SOFA architecture integrates the Lookout SDK for state measurement by default.
- Finally, of course, there is no silver bullet in the monitoring area, and the metrics-based lookout is suitable for early warning of macro trends (such as, the number of error requests within a minute), and is not good at tracing a wrong event (for example, The reason for the error of a call).

We have accumulated some experience in distributed scenarios, but we are also in the process of exploration. We hope to get help from you.

## Building
Maven 3.2.5+, JDK Version 1.6+

## Contributing
Refer to [CONTRIBUTING.md](./CONTRIBUTING.md)

## Sincere thanks
Lookout's promQL related parsing logic was ported from Prometheus, with some optimizations and improvements, thanks to Prometheus open source for such an easy to use and powerful QL implementation of the golang version.

## License
Apache License 2.0, see [LICENSE](./LICENSE).
